#ifndef __KEYBOARD_H__
#define __KEYBOARD_H__ 1

#include "../types.h"

extern unsigned char keystateBits[];

struct KeyboardKeydownState {
  byte KEY_W;
  byte KEY_A;
  byte KEY_S;
  byte KEY_D;
  byte KEY_I;
  byte KEY_O;
  byte KEY_P;
  byte KEY_ESC;
};

extern struct KeyboardKeydownState keyboardKeydownState;

void installKeyboardHandler();
void uninstallKeyboardHandler();
void populateKeyboardKeydownState();

#endif
