#ifndef __PC_STUFF_H__
#define __PC_STUFF_H__

#include <conio.h>
#include <dos.h>

#include "../types.h"

extern byte *VGA;

#define BIOS_GET_VIDEO_MODE   (0x0F)
#define BIOS_VIDEO_INTERRUPT  (0x10)

#define VIDEO_MODE_VGA_256    (0x13)
#define VIDEO_MODE_80x25_TEXT (0x03)

// remember, little endian, so the "first" value is "last"
#define outpw_to_register(indexPort, dataRegister, data) \
  outpw(indexPort, (((word)(data) << 8)) + (dataRegister))

#endif

void setVideoMode(byte);
void waitStartVbl();
void waitEndVbl();
void writeString(char *, int x, int y);
