#ifndef __GAME_H__
#define __GAME_H__

#include "system/vga.h"

extern struct CompiledSpriteRender rabbit, mouse, bullet, enemy, enemyBullet, shotgun, shieldKiller;
extern struct SpriteBounds bounds;

struct GlobalGameState {
  int difficulty;
  int spawnCooldown;
  int kills;
  int health;
  int maxHealth;
  int healthGainPerKill;
  int coins;

  int damageUpgradeLevel;
  int healthUpgradeLevel;
  int healthGainUpgradeLevel;
};

#endif
