#ifndef __SPAWN_H__
#define __SPAWN_H__

#include "game.h"
#include "movement.h"

void maybeSpawnEnemy(
  struct GlobalGameState*, struct EnemyPosition[], struct RabbitPosition*
);

struct EnemySpawningDetails {
  struct EnemyPosition *enemyPosition;
  int gate;
  int difficulty;
  int spawnX;
  int spawnY;
};

struct SpawnPointRange {
  int left, width;
  int top, height;
};

extern struct SpawnPointRange spawnPointRanges[];

#endif
