#ifndef __SPRITES_H__
#define __SPRITES_H__

#include "types.h"
#include "system/vga.h"

#define PALETTE_COLOR_COUNT (17)

extern struct VGAColor palette[17];


extern void sprite_arenaWallTop(byte *);

#define SPRITE_ARENAWALLTOP_WIDTH (20)

#define SPRITE_ARENAWALLTOP_HEIGHT (20)

#define SPRITE_ARENAWALLTOP_OFFSET_X (0)

#define SPRITE_ARENAWALLTOP_OFFSET_Y (0)


extern void sprite_arenaWallSide(byte *);

#define SPRITE_ARENAWALLSIDE_WIDTH (20)

#define SPRITE_ARENAWALLSIDE_HEIGHT (20)

#define SPRITE_ARENAWALLSIDE_OFFSET_X (0)

#define SPRITE_ARENAWALLSIDE_OFFSET_Y (0)


extern void sprite_arenaFloor(byte *);

#define SPRITE_ARENAFLOOR_WIDTH (20)

#define SPRITE_ARENAFLOOR_HEIGHT (20)

#define SPRITE_ARENAFLOOR_OFFSET_X (0)

#define SPRITE_ARENAFLOOR_OFFSET_Y (0)


extern void sprite_rabbit(byte *);

#define SPRITE_RABBIT_WIDTH (16)

#define SPRITE_RABBIT_HEIGHT (16)

#define SPRITE_RABBIT_OFFSET_X (8)

#define SPRITE_RABBIT_OFFSET_Y (8)


extern void sprite_mouse(byte *);

#define SPRITE_MOUSE_WIDTH (8)

#define SPRITE_MOUSE_HEIGHT (8)

#define SPRITE_MOUSE_OFFSET_X (4)

#define SPRITE_MOUSE_OFFSET_Y (4)


extern void sprite_bullet(byte *);

#define SPRITE_BULLET_WIDTH (2)

#define SPRITE_BULLET_HEIGHT (2)

#define SPRITE_BULLET_OFFSET_X (1)

#define SPRITE_BULLET_OFFSET_Y (1)


extern void sprite_enemy(byte *);

#define SPRITE_ENEMY_WIDTH (16)

#define SPRITE_ENEMY_HEIGHT (16)

#define SPRITE_ENEMY_OFFSET_X (8)

#define SPRITE_ENEMY_OFFSET_Y (8)


extern void sprite_shotgun(byte *);

#define SPRITE_SHOTGUN_WIDTH (12)

#define SPRITE_SHOTGUN_HEIGHT (12)

#define SPRITE_SHOTGUN_OFFSET_X (6)

#define SPRITE_SHOTGUN_OFFSET_Y (6)


extern void sprite_beam(byte *);

#define SPRITE_BEAM_WIDTH (12)

#define SPRITE_BEAM_HEIGHT (12)

#define SPRITE_BEAM_OFFSET_X (6)

#define SPRITE_BEAM_OFFSET_Y (6)



#endif
