#include "vga.h"

struct MouseStatus {
  int isActive;
  int buttonCount;
  int xPosition;
  int yPosition;
  int leftButtonDown;
  int rightButtonDown;
};

#define MOUSE_DRIVER_INTERRUPT (0x33)
#define MOUSE_DRIVER_RESET (0x00)
#define MOUSE_DRIVER_READ_DELTA_MOTION (0x0B)
#define MOUSE_DRIVER_READ_STATE (0x03);

int activateMouse(struct MouseStatus *);
int limitMouseArea(int sx, int sy, int ex, int ey);
void readMouse(struct MouseStatus *);
